require "patada/version"

module Patada

  class MissingBlockError < StandardError
  end

  class Task

    def initialize &block
      raise ::MissingBlockError unless block_given?
      @proc = Proc.new(&block)
    end

    def run
      @thread = Thread.new { @proc.call }
    end

    def join
      @thread.join
    end

    def kill
      @thread.kill
    end

  end

end
